# QuTiP’s internals

This section documents some of the internals of the QuTiP code base, in particular, the data layer that allows quantum objects to be stored in different representations internally. It is intended for people who are looking to modify and extend QuTiP, particularly the lower-level, more heavily optimised components. See also the general Development Documentation in this guide.

In general we assume that you have a working knowledge of using QuTiP as a user, and these pages will not contain a tutorial on how to work with the library. If that is what you are looking for, please refer to the Users Guide or the large collection of example notebooks.

Guide Contents:

- Quantum Objects
  - Data Store
  - Auxiliary Information
  - Methods
  - Derived and Related Types
- Data Layer
  - Terminology
  - Motivation
  - Converting Between Types: `to`
  - Dispatch Operations: `Dispatcher`
  - Type Descriptions